DomHandler (Java Platform SE 8 )
Keywords: javax.xml.bind.annotation.DomHandler interface
Date: 2026-04-17

javax.xml.bind.annotation

## Interface DomHandler<ElementT,ResultT extends Result>

- All Known Implementing Classes:
    W3CDomHandler

      public interface DomHandler<ElementT,ResultT extends Result>

  Converts an element (and its descendants) from/to DOM (or similar) representation.

  Implementations of this interface will be used in conjunction with `XmlAnyElement` annotation to map an element of XML into a representation of infoset such as W3C DOM.

  Implementations hide how a portion of XML is converted into/from such DOM-like representation, allowing JAXB providers to work with arbitrary such library.

  This interface is intended to be implemented by library writers and consumed by JAXB providers. None of those methods are intended to be called from applications.

  Since:
    JAXB2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `ResultT` | `createUnmarshaller(ValidationEventHandler errorHandler)` When a JAXB provider needs to unmarshal a part of a document into an infoset representation, it first calls this method to create a `Result` object.
    `ElementT` | `getElement(ResultT rt)` Once the portion is sent to the `Result`.
    `Source` | `marshal(ElementT n, ValidationEventHandler errorHandler)` This method is called when a JAXB provider needs to marshal an element to XML.

- - ### Method Detail

    - #### createUnmarshaller

          ResultT createUnmarshaller(ValidationEventHandler errorHandler)

      When a JAXB provider needs to unmarshal a part of a document into an infoset representation, it first calls this method to create a `Result` object.

      A JAXB provider will then send a portion of the XML into the given result. Such a portion always form a subtree of the whole XML document rooted at an element.

      Parameters:
        `errorHandler` - if any error happens between the invocation of this method and the invocation of `getElement(Result)`, they must be reported to this handler. The caller must provide a non-null error handler. The `Result` object created from this method may hold a reference to this error handler.
      Returns:
        null if the operation fails. The error must have been reported to the error handler.

    - #### getElement

          ElementT getElement(ResultT rt)

      Once the portion is sent to the `Result`. This method is called by a JAXB provider to obtain the unmarshalled element representation.

      Multiple invocations of this method may return different objects. This method can be invoked only when the whole sub-tree are fed to the `Result` object.

      Parameters:
        `rt` - The `Result` object created by `createUnmarshaller(ValidationEventHandler)`.
      Returns:
        null if the operation fails. The error must have been reported to the error handler.

    - #### marshal

          Source marshal(ElementT n,
                         ValidationEventHandler errorHandler)

      This method is called when a JAXB provider needs to marshal an element to XML.

      If non-null, the returned `Source` must contain a whole document rooted at one element, which will then be weaved into a bigger document that the JAXB provider is marshalling.

      Parameters:
        `errorHandler` - Receives any errors happened during the process of converting an element into a `Source`. The caller must provide a non-null error handler.
      Returns:
        null if there was an error. The error should have been reported to the handler.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.